' Import MySQL Data and MySqlClient
Imports MySql.Data
Imports MySql.Data.MySqlClient

Partial Class Register
    Inherits System.Web.UI.Page

    Protected Sub btnRegister_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnRegister.Click

        ' Takes the data from the form at "Insert-into-mysql.aspx" when the button is clicked and then Inserts 
        ' this data to the table "Users" in the specified fields.

        ' Set the SqlEx label to a empty string.
        SqlEx.Text = String.Empty

        Try
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "INSERT INTO Users (Username, Password, Company, OrgNumber, Contact, Attention, Adress, PostalCode, City, Country, RegisterDate, ExpireDate, Admin) VALUES (@Username, @Password, @Company, @OrgNumber, @Contact, @Attention, @Adress, @PostalCode, @City, @Country, @RegisterDate, @ExpireDate, @Admin)"

            ' The Using block is used to call dispose (close) automatically even if there are an exception. A new
            ' MySqlConnection and a new MySqlCommand are created.
            Using cn As New MySqlConnection(ConnString), _
                  cmd As New MySqlCommand(sql, cn)

                ' Add parameters for the WHERE clause, parameters are used to make it hard for hackers to modify
                ' the sql statement.
                cmd.Parameters.AddWithValue("@Username", txtUserName.Text)
                cmd.Parameters.AddWithValue("@Password", txtPassword.Text)
                cmd.Parameters.AddWithValue("@Company", txtCompanyName.Text)
                cmd.Parameters.AddWithValue("@OrgNumber", txtOrganisationNumber.Text)
                cmd.Parameters.AddWithValue("@Contact", txtContact.Text)
                cmd.Parameters.AddWithValue("@Attention", txtAttention.Text)
                cmd.Parameters.AddWithValue("@Adress", txtAdress.Text)
                cmd.Parameters.AddWithValue("@PostalCode", txtPostalCode.Text)
                cmd.Parameters.AddWithValue("@City", txtCity.Text)
                cmd.Parameters.AddWithValue("@Country", txtCountry.Text)
                cmd.Parameters.AddWithValue("@RegisterDate", DateTime.Now.ToString())
                cmd.Parameters.AddWithValue("@ExpireDate", DateTime.Now.AddYears(1).ToString())
                cmd.Parameters.AddWithValue("@Admin", 0)

                ' Open the MySql connection, will be closed in the End Using statement.
                cn.Open()

                ' Execute the INSERT statement.
                cmd.ExecuteNonQuery()

                ' Set visibility for panels.
                CurrentPanel.Visible = False
                ThankYouPanel.Visible = True

            End Using

        Catch SqlExc As MySqlException

            ' Catch a MySqlException
            Select Case SqlExc.Number
                Case 2601
                    SqlEx.Text = "* Given E-mail already exists"
                Case Else
                    Response.Write(SqlExc.Message)
            End Select

        Catch Ex As Exception

            ' Catch a general exception that is not a MySqlException
            Response.Write(Ex.Message)

        End Try

    End Sub
End Class
