using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

// Import MySql Data and MySqlClient
using MySql.Data;
using MySql.Data.MySqlClient;

public partial class _Register : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        // Insert code for the page load event here
    }

    protected void btnRegister_Click(object sender, EventArgs e)
    {
        // Set the SqlEx label to a empty string
        SqlEx.Text = string.Empty;

        // Declare variables for the connection string and the INSERT INTO statement.
        string ConnString = ConfigurationManager.ConnectionStrings["ConnectionString"].ToString();
        string sql = "INSERT INTO Users (Username, Password, Company, OrgNumber, Contact, Attention, Adress, "
        + "PostalCode, City, Country, RegisterDate, ExpireDate, Admin) VALUES (@Username, @Password, @Company, " 
        + "@OrgNumber, @Contact, @Attention, @Adress, @PostalCode, @City, @Country, @RegisterDate, @ExpireDate, "
        + "@Admin)";

        // The using block is used to call dispose automatically even if there are an exception.
        using (MySqlConnection cn = new MySqlConnection(ConnString))
        {
            // Create a new MySql command to be able to execute the INSERT statement, add the sql string and the
            // MySql connection cn as parameters.
            MySqlCommand cmd = new MySqlCommand(sql, cn);

            // Add parameters for the WHERE clause, parameters are used to make it hard for hackers to modify
            // the sql statement.
            cmd.Parameters.AddWithValue("@Username", txtUserName.Text);
            cmd.Parameters.AddWithValue("@Password", txtPassword.Text);
            cmd.Parameters.AddWithValue("@Company", txtCompanyName.Text);
            cmd.Parameters.AddWithValue("@OrgNumber", txtOrganisationNumber.Text);
            cmd.Parameters.AddWithValue("@Contact", txtContact.Text);
            cmd.Parameters.AddWithValue("@Attention", txtAttention.Text);
            cmd.Parameters.AddWithValue("@Adress", txtAdress.Text);
            cmd.Parameters.AddWithValue("@PostalCode", txtPostalCode.Text);
            cmd.Parameters.AddWithValue("@City", txtCity.Text);
            cmd.Parameters.AddWithValue("@Country", txtCountry.Text);
            cmd.Parameters.AddWithValue("@RegisterDate", DateTime.Now.ToString());
            cmd.Parameters.AddWithValue("@ExpireDate", DateTime.Now.AddYears(1).ToString());
            cmd.Parameters.AddWithValue("@Admin", 0);

            // The Try/Catch/Finally statement is used to handle unusual exceptions in the code to
            // avoid having our application to crash in such cases.
            try
            {
                // Open the MySql connection, will be closed when the end of the using block have been reached.
                cn.Open();

                // Execute the INSERT command.
                cmd.ExecuteNonQuery();

                // Set visibility for panels
                CurrentPanel.Visible = false;
                ThankYouPanel.Visible = true;
            }
            catch (MySqlException sqlExc)
            {
                // Catch a MySqlException
                switch (sqlExc.Number)
                {
                    case 2601:
                        SqlEx.Text = "* Given E-mail already exists";
                        break;
                    default:
                        Response.Write(sqlExc.Message);
                        break;
                }
            }
            catch (Exception Ex)
            {
                // Catch a general exception that is not a MySqlException.
                Response.Write(Ex.Message);
            }
            finally
            {
                // Call Dispose for the MySqlCommand to avoid memory leakage.
                cmd.Dispose();
            }
        }
    }
}
